include \masm32\include\masm32rt.inc
.686
include timers.asm

debug macro args:vararg
	pushad
	% print args
	popad
endm

include lalist.asm
include llist.asm

.code
start:
	
	call llCreate
	mov edi, eax
	
	mov esi, 0
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	add esi, 1
	push esi
	push edi
	call llAdd
	counter_end
	debug "LList Add: "
	debug <ustr$(eax)>, 10
	
	push edi
	call llIterateStart
	mov esi, eax
	
	; iterate
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	push esi
	call llIterateNext
	counter_end
	debug "LList Iterate: "
	debug <ustr$(eax)>, 10
	
	push esi
	call llIterateEnd
	
	push edi
	call llIterateStart
	mov esi, eax
	
	; remove all
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	push esi
	call llIterateNext
	push esi
	call llIterateRemove
	counter_end
	debug "LList Iterate + remove: "
	debug <ustr$(eax)>, 10
	
	push ebx
	call laIterateEnd
	
	
	
	call laCreate
	mov edi, eax
	
	mov esi, 0
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	add esi, 1
	push esi
	push edi
	call laAdd
	counter_end
	debug "LAList Add: "
	debug <ustr$(eax)>, 10
	
	push edi
	call laIterateStart
	mov esi, eax
	
	; iterate
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	push esi
	call laIterateNext
	counter_end
	debug "LAList Iterate: "
	debug <ustr$(eax)>, 10
	
	push esi
	call laIterateEnd
	
	push edi
	call laIterateStart
	mov esi, eax
	
	; remove all
	counter_begin 1000000, HIGH_PRIORITY_CLASS
	push esi
	call laIterateNext
	push esi
	call laIterateRemove
	counter_end
	debug "LAList Iterate + remove: "
	debug <ustr$(eax)>, 10
	
	push ebx
	call laIterateEnd
	
	push edi
	call laDestroy
	
	inkey
	
	exit

end start